/*
 * apikeydialog.cpp
 *
 *  Created on: 15.3.2010
 *      Author: aahv
 */

#include <QPushButton>
#include <QMessageBox>

#include "apikeydialog.h"
#include "ui_apikeydialog.h"

ApiKeyDialog::ApiKeyDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ApiKeyDialog)
{
    ui->setupUi(this);

    ui->apiKeyText->SetExplanation(tr("API key"));

#ifdef Q_OS_SYMBIAN
    QAction* leftSoftKey = new QAction(tr("Ok"), this);
    connect(leftSoftKey, SIGNAL(triggered()), this, SLOT(onOk()));
    leftSoftKey->setSoftKeyRole(QAction::PositiveSoftKey);
    addAction(leftSoftKey);
    QAction* rightSoftKey = new QAction(tr("Cancel"), this);
    connect(rightSoftKey, SIGNAL(triggered()), this, SLOT(onCancel()));
    rightSoftKey->setSoftKeyRole(QAction::NegativeSoftKey);
    addAction(rightSoftKey);
#else
    QPushButton* okButton = new QPushButton(tr("Ok"));
    connect(okButton, SIGNAL(clicked()), this, SLOT(onOk()));
    QPushButton* cancelButton = new QPushButton(tr("Cancel"));
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(onCancel()));

    QHBoxLayout* buttonLayout = new QHBoxLayout();
    buttonLayout->addWidget(okButton);
    buttonLayout->addWidget(cancelButton);

    ui->verticalLayout->addLayout(buttonLayout);
#endif
}

ApiKeyDialog::~ApiKeyDialog()
{
    delete ui;
}

void ApiKeyDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void ApiKeyDialog::onOk() {
    QString str = ui->apiKeyText->text().trimmed();
    if (str.length() == 12) {
        emit setApiKey(str);
        accept();
    } else {
        QMessageBox::warning(this, tr("Invalid API key"), tr("Invalid API key. It must be 12 characters long."), QMessageBox::Close, QMessageBox::Close);
    }
}

void ApiKeyDialog::onCancel() {
    ui->apiKeyText->Clear();
    reject();
}
